diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
index 878664f2f..d8b60d364 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
@@ -64,8 +64,8 @@ public class BlockModelFullyRotatable<T extends BlockLogic> extends BlockModelSt
 
 
     @Override
-    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
-        super.renderStandalone(tessellator, 1, lightmapCoord);
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, byte lightIndex) {
+        super.renderStandalone(tessellator, 1, lightIndex);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
index c0b1680e4..d3c22d0e8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
@@ -16,9 +16,9 @@ public class BlockModelLayer<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, byte lightIndex) {
         tessellator.offsetTranslation(0, 0.25, 0);
-        super.renderStandalone(tessellator, metadata, lightmapCoord);
+        super.renderStandalone(tessellator, metadata, lightIndex);
         tessellator.offsetTranslation(0, -0.25, 0);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
index 9ddaa60b5..bb19203f6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
@@ -33,10 +33,10 @@ public class BlockModelLeaves<T extends BlockLogic> extends BlockModelStandard<T
     }
 
     @Override
-    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, byte lightIndex) {
         boolean invTint = renderBlocks.useInventoryTint;
         renderBlocks.useInventoryTint = !this.canBeRetro || !isRetro();
-        super.renderStandalone(tessellator, metadata, lightmapCoord);
+        super.renderStandalone(tessellator, metadata, lightIndex);
         renderBlocks.useInventoryTint = invTint;
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
index f1625b7fa..deb393612 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
@@ -31,7 +31,7 @@ public class BlockModelRail<T extends BlockLogicRail> extends BlockModelStandard
         }
         RailDirection railDirection = this.block.getLogic().getRailDirection(worldSource, tilePos);
         float brightness = 1.0f;
-        tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos));
+        tessellator.setLightmapCoord1i(this.block.getLightIndex(worldSource, tilePos));
         if (icon == null) {
             return false;
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
index cbee89718..81fe3ee8d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
@@ -63,7 +63,7 @@ public class BlockModelStairs<T extends BlockLogicStairs> extends BlockModelStan
     }
 
     @Override
-    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, byte lightIndex) {
         tessellator.offsetTranslation(-0.5, -0.5, -0.5);
         tessellator.startDrawingQuads();
         tessellator.setColor1i(getStandaloneTintColor(metadata));
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
index adae8ffdd..666176f6e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
@@ -73,16 +73,16 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T> {
     }
 
     @Override
-    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, byte lightIndex) {
         AABBdc bounds = getBlockBoundsForItemRender();
         tessellator.offsetTranslation(-0.5, -0.5, -0.5);
-        renderBlockWithBounds(tessellator, bounds, metadata, lightmapCoord, getStandaloneTintColor(metadata));
+        renderBlockWithBounds(tessellator, bounds, metadata, lightIndex, getStandaloneTintColor(metadata));
         tessellator.offsetTranslation(0.5F, 0.5, 0.5F);
     }
 
-    public final void renderBlockWithBounds(@NotNull TessellatorGeneral tessellator, @NotNull AABBdc bounds, int metadata, int lightmapCoord, int color) {
+    public final void renderBlockWithBounds(@NotNull TessellatorGeneral tessellator, @NotNull AABBdc bounds, int metadata, byte lightIndex, int color) {
         tessellator.startDrawingQuads();
-        tessellator.setLightmapCoord1i(lightmapCoord);
+        tessellator.setLightmapCoord1i(lightIndex);
         tessellator.setColor1i(color);
 
         tessellator.setNormal(0.0f, -1.0f, 0.0f);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
index 13dbccce2..14cf408fd 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
@@ -69,9 +69,9 @@ public class BlockModelTrapDoor<T extends BlockLogic> extends BlockModelStandard
     }
 
     @Override
-    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, byte lightIndex) {
         tessellator.offsetTranslation(0, 0.25, 0);
-        super.renderStandalone(tessellator, metadata, lightmapCoord);
+        super.renderStandalone(tessellator, metadata, lightIndex);
         tessellator.offsetTranslation(0, -0.25, 0);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
index 0310391f4..470553f46 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
@@ -48,10 +48,10 @@ public class BlockModelVeryRotatable<T extends BlockLogic> extends BlockModelSta
 
 
     @Override
-    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, byte lightIndex) {
         renderBlocks.uvRotateTop = 1;
         renderBlocks.uvRotateBottom = 1;
-        super.renderStandalone(tessellator, 3, lightmapCoord);
+        super.renderStandalone(tessellator, 3, lightIndex);
         renderBlocks.resetRenderBlocks();
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
index a6102efdf..1598a4d1e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -41,8 +40,7 @@ public class BlockModelWireRedstone<T extends BlockLogic> extends BlockModelStan
 
         TilePos queryPos = new TilePos();
 
-        int lmc = LightmapHelper.getLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, tilePos), Math.max(worldSource.getSavedLightValue(LightLayer.Block, tilePos), meta & 0xF));
-        tessellator.setLightmapCoord1i(lmc);
+        tessellator.setLightmapCoord2i(worldSource.getSavedLightValue(LightLayer.Sky, tilePos), Math.max(worldSource.getSavedLightValue(LightLayer.Block, tilePos), meta & 0xF));
         tessellator.setColorOpaque3f(red, green, blue);
         boolean west = BlockLogicWireRedstone.shouldConnectTo(worldSource, tilePos.west(queryPos), Side.WEST) || !worldSource.isBlockNormalCube(tilePos.west(queryPos)) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, tilePos.add(-1, -1, 0, queryPos), Side.NONE, Side.BOTTOM);
         boolean east = BlockLogicWireRedstone.shouldConnectTo(worldSource, tilePos.east(queryPos), Side.EAST) || !worldSource.isBlockNormalCube(tilePos.east(queryPos)) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, tilePos.add(1, -1, 0, queryPos), Side.NONE, Side.BOTTOM);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
index ef1b1e6fb..3a8eb749c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightingCache;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
@@ -44,10 +44,14 @@ public final class RenderBlocks {
     public float colorBlueBottomLeft;
     public float colorBlueBottomRight;
     public float colorBlueTopRight;
-    public int lightmapCoordTopLeft;
-    public int lightmapCoordBottomLeft;
-    public int lightmapCoordBottomRight;
-    public int lightmapCoordTopRight;
+    public float shadeTopLeft;
+    public float shadeBottomLeft;
+    public float shadeBottomRight;
+    public float shadeTopRight;
+    public int lightIndexTopLeft;
+    public int lightIndexBottomLeft;
+    public int lightIndexBottomRight;
+    public int lightIndexTopRight;
     public LightingCache cache = new LightingCache();
 
     public RenderBlocks() {
@@ -267,30 +271,30 @@ public final class RenderBlocks {
             boolean botLefT = this.cache.getOpacity(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ);
             boolean botRigT = this.cache.getOpacity(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ);
 
-            int lmcCen = this.cache.getLightmapCoord(dirX2, dirY2, dirZ2);
+            byte lmcCen = this.cache.getLightIndex(dirX2, dirY2, dirZ2);
 
-            int lmcTop = topT ? lmcCen : this.cache.getLightmapCoord(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
-            int lmcBot = botT ? lmcCen : this.cache.getLightmapCoord(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
-            int lmcLef = lefT ? lmcCen : this.cache.getLightmapCoord(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
-            int lmcRig = rigT ? lmcCen : this.cache.getLightmapCoord(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
+            byte lmcTop = topT ? lmcCen : this.cache.getLightIndex(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
+            byte lmcBot = botT ? lmcCen : this.cache.getLightIndex(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
+            byte lmcLef = lefT ? lmcCen : this.cache.getLightIndex(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
+            byte lmcRig = rigT ? lmcCen : this.cache.getLightIndex(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
 
-            int lmcTopLef = topT && lefT ? lmcLef : (topLefT ? lmcCen : this.cache.getLightmapCoord(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ));
-            int lmcBotLef = botT && lefT ? lmcLef : (botLefT ? lmcCen : this.cache.getLightmapCoord(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ));
-            int lmcTopRig = topT && rigT ? lmcRig : (topRigT ? lmcCen : this.cache.getLightmapCoord(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ));
-            int lmcBotRig = botT && rigT ? lmcRig : (botRigT ? lmcCen : this.cache.getLightmapCoord(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ));
+            byte lmcTopLef = topT && lefT ? lmcLef : (topLefT ? lmcCen : this.cache.getLightIndex(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ));
+            byte lmcBotLef = botT && lefT ? lmcLef : (botLefT ? lmcCen : this.cache.getLightIndex(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ));
+            byte lmcTopRig = topT && rigT ? lmcRig : (topRigT ? lmcCen : this.cache.getLightIndex(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ));
+            byte lmcBotRig = botT && rigT ? lmcRig : (botRigT ? lmcCen : this.cache.getLightIndex(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ));
 
-            this.lightmapCoordTopLeft = LightmapHelper.avg(lmcCen, lmcLef, lmcTop, lmcTopLef);
-            this.lightmapCoordTopRight = LightmapHelper.avg(lmcCen, lmcRig, lmcTop, lmcTopRig);
-            this.lightmapCoordBottomLeft = LightmapHelper.avg(lmcCen, lmcLef, lmcBot, lmcBotLef);
-            this.lightmapCoordBottomRight = LightmapHelper.avg(lmcCen, lmcRig, lmcBot, lmcBotRig);
+            this.lightIndexTopLeft = LightIndexHelper.avg(lmcCen, lmcLef, lmcTop, lmcTopLef);
+            this.lightIndexTopRight = LightIndexHelper.avg(lmcCen, lmcRig, lmcTop, lmcTopRig);
+            this.lightIndexBottomLeft = LightIndexHelper.avg(lmcCen, lmcLef, lmcBot, lmcBotLef);
+            this.lightIndexBottomRight = LightIndexHelper.avg(lmcCen, lmcRig, lmcBot, lmcBotRig);
         } else {
             int lmc;
             if (!isFullCube) {
-                lmc = block.getLightmapCoord(worldSource, tilePos);
+                lmc = block.getLightIndex(worldSource, tilePos);
             } else {
-                lmc = block.getLightmapCoord(worldSource, tilePos.add(dirX, dirY, dirZ, new TilePos()));
+                lmc = block.getLightIndex(worldSource, tilePos.add(dirX, dirY, dirZ, new TilePos()));
             }
-            this.lightmapCoordTopLeft = this.lightmapCoordBottomLeft = this.lightmapCoordBottomRight = this.lightmapCoordTopRight = lmc;
+            this.lightIndexTopLeft = this.lightIndexBottomLeft = this.lightIndexBottomRight = this.lightIndexTopRight = lmc;
         }
 
         float lightTR;
@@ -363,21 +367,10 @@ public final class RenderBlocks {
         float lbl = lefP * bl + (1 - lefP) * br;
         float lbr = rigP * bl + (1 - rigP) * br;
         float ltr = rigP * tl + (1 - rigP) * tr;
-        this.colorRedTopLeft *= ltl;
-        this.colorGreenTopLeft *= ltl;
-        this.colorBlueTopLeft *= ltl;
-
-        this.colorRedBottomLeft *= lbl;
-        this.colorGreenBottomLeft *= lbl;
-        this.colorBlueBottomLeft *= lbl;
-
-        this.colorRedBottomRight *= lbr;
-        this.colorGreenBottomRight *= lbr;
-        this.colorBlueBottomRight *= lbr;
-
-        this.colorRedTopRight *= ltr;
-        this.colorGreenTopRight *= ltr;
-        this.colorBlueTopRight *= ltr;
+        this.shadeTopLeft = ltl;
+        this.shadeBottomLeft = lbl;
+        this.shadeBottomRight = lbr;
+        this.shadeTopRight = ltr;
     }
 
     public void renderBottomFace(@NotNull TessellatorGeneral tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
@@ -442,16 +435,20 @@ public final class RenderBlocks {
         double d15 = z + bounds.maxZ();
         tessellator.setNormal(0, -1, 0);
         if (this.enableAO) {
-            tessellator.setLightmapCoord1i(this.lightmapCoordTopLeft);
+            tessellator.setLightmapCoord1i(this.lightIndexTopLeft);
+            tessellator.setShade1i((int) (this.shadeTopLeft * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
             tessellator.addVertexWithUV(d11, d13, d15, d8, d10);
-            tessellator.setLightmapCoord1i(this.lightmapCoordBottomLeft);
+            tessellator.setLightmapCoord1i(this.lightIndexBottomLeft);
+            tessellator.setShade1i((int) (this.shadeBottomLeft * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedBottomLeft, this.colorGreenBottomLeft, this.colorBlueBottomLeft);
             tessellator.addVertexWithUV(d11, d13, d14, d3, d5);
-            tessellator.setLightmapCoord1i(this.lightmapCoordBottomRight);
+            tessellator.setLightmapCoord1i(this.lightIndexBottomRight);
+            tessellator.setShade1i((int) (this.shadeBottomRight * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedBottomRight, this.colorGreenBottomRight, this.colorBlueBottomRight);
             tessellator.addVertexWithUV(d12, d13, d14, d7, d9);
-            tessellator.setLightmapCoord1i(this.lightmapCoordTopRight);
+            tessellator.setLightmapCoord1i(this.lightIndexTopRight);
+            tessellator.setShade1i((int) (this.shadeTopRight * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedTopRight, this.colorGreenTopRight, this.colorBlueTopRight);
             tessellator.addVertexWithUV(d12, d13, d15, d4, d6);
         } else {
@@ -525,16 +522,20 @@ public final class RenderBlocks {
         double d15 = z + bounds.maxZ();
         tessellator.setNormal(0, 1, 0);
         if (this.enableAO) {
-            tessellator.setLightmapCoord1i(this.lightmapCoordTopLeft);
+            tessellator.setLightmapCoord1i(this.lightIndexTopLeft);
+            tessellator.setShade1i((int) (this.shadeTopLeft * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
             tessellator.addVertexWithUV(d12, d13, d15, d4, d6);
-            tessellator.setLightmapCoord1i(this.lightmapCoordBottomLeft);
+            tessellator.setLightmapCoord1i(this.lightIndexBottomLeft);
+            tessellator.setShade1i((int) (this.shadeBottomLeft * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedBottomLeft, this.colorGreenBottomLeft, this.colorBlueBottomLeft);
             tessellator.addVertexWithUV(d12, d13, d14, d7, d9);
-            tessellator.setLightmapCoord1i(this.lightmapCoordBottomRight);
+            tessellator.setLightmapCoord1i(this.lightIndexBottomRight);
+            tessellator.setShade1i((int) (this.shadeBottomRight * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedBottomRight, this.colorGreenBottomRight, this.colorBlueBottomRight);
             tessellator.addVertexWithUV(d11, d13, d14, d3, d5);
-            tessellator.setLightmapCoord1i(this.lightmapCoordTopRight);
+            tessellator.setLightmapCoord1i(this.lightIndexTopRight);
+            tessellator.setShade1i((int) (this.shadeTopRight * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedTopRight, this.colorGreenTopRight, this.colorBlueTopRight);
             tessellator.addVertexWithUV(d11, d13, d15, d8, d10);
         } else {
@@ -613,16 +614,20 @@ public final class RenderBlocks {
         double d16 = z + bounds.minZ();
         tessellator.setNormal(0, 0, -1);
         if (this.enableAO) {
-            tessellator.setLightmapCoord1i(this.lightmapCoordTopLeft);
+            tessellator.setLightmapCoord1i(this.lightIndexTopLeft);
+            tessellator.setShade1i((int) (this.shadeTopLeft * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
             tessellator.addVertexWithUV(d12, d15, d16, d8, d10);
-            tessellator.setLightmapCoord1i(this.lightmapCoordBottomLeft);
+            tessellator.setLightmapCoord1i(this.lightIndexBottomLeft);
+            tessellator.setShade1i((int) (this.shadeBottomLeft * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedBottomLeft, this.colorGreenBottomLeft, this.colorBlueBottomLeft);
             tessellator.addVertexWithUV(d13, d15, d16, d3, d5);
-            tessellator.setLightmapCoord1i(this.lightmapCoordBottomRight);
+            tessellator.setLightmapCoord1i(this.lightIndexBottomRight);
+            tessellator.setShade1i((int) (this.shadeBottomRight * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedBottomRight, this.colorGreenBottomRight, this.colorBlueBottomRight);
             tessellator.addVertexWithUV(d13, d14, d16, d9, d11);
-            tessellator.setLightmapCoord1i(this.lightmapCoordTopRight);
+            tessellator.setLightmapCoord1i(this.lightIndexTopRight);
+            tessellator.setShade1i((int) (this.shadeTopRight * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedTopRight, this.colorGreenTopRight, this.colorBlueTopRight);
             tessellator.addVertexWithUV(d12, d14, d16, d4, d6);
         } else {
@@ -701,16 +706,20 @@ public final class RenderBlocks {
         double z0 = z + bounds.maxZ();
         tessellator.setNormal(0, 0, 1);
         if (this.enableAO) {
-            tessellator.setLightmapCoord1i(this.lightmapCoordTopLeft);
+            tessellator.setLightmapCoord1i(this.lightIndexTopLeft);
+            tessellator.setShade1i((int) (this.shadeTopLeft * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
             tessellator.addVertexWithUV(x0, y1, z0, d3, d5);
-            tessellator.setLightmapCoord1i(this.lightmapCoordBottomLeft);
+            tessellator.setLightmapCoord1i(this.lightIndexBottomLeft);
+            tessellator.setShade1i((int) (this.shadeBottomLeft * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedBottomLeft, this.colorGreenBottomLeft, this.colorBlueBottomLeft);
             tessellator.addVertexWithUV(x0, y0, z0, d9, d11);
-            tessellator.setLightmapCoord1i(this.lightmapCoordBottomRight);
+            tessellator.setLightmapCoord1i(this.lightIndexBottomRight);
+            tessellator.setShade1i((int) (this.shadeBottomRight * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedBottomRight, this.colorGreenBottomRight, this.colorBlueBottomRight);
             tessellator.addVertexWithUV(x1, y0, z0, d4, d6);
-            tessellator.setLightmapCoord1i(this.lightmapCoordTopRight);
+            tessellator.setLightmapCoord1i(this.lightIndexTopRight);
+            tessellator.setShade1i((int) (this.shadeTopRight * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedTopRight, this.colorGreenTopRight, this.colorBlueTopRight);
             tessellator.addVertexWithUV(x1, y1, z0, d8, d10);
         } else {
@@ -789,16 +798,20 @@ public final class RenderBlocks {
         double d16 = z + bounds.maxZ();
         tessellator.setNormal(-1, 0, 0);
         if (this.enableAO) {
-            tessellator.setLightmapCoord1i(this.lightmapCoordTopLeft);
+            tessellator.setLightmapCoord1i(this.lightIndexTopLeft);
+            tessellator.setShade1i((int) (this.shadeTopLeft * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
             tessellator.addVertexWithUV(d12, d14, d16, d8, d10);
-            tessellator.setLightmapCoord1i(this.lightmapCoordBottomLeft);
+            tessellator.setLightmapCoord1i(this.lightIndexBottomLeft);
+            tessellator.setShade1i((int) (this.shadeBottomLeft * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedBottomLeft, this.colorGreenBottomLeft, this.colorBlueBottomLeft);
             tessellator.addVertexWithUV(d12, d14, d15, d3, d5);
-            tessellator.setLightmapCoord1i(this.lightmapCoordBottomRight);
+            tessellator.setLightmapCoord1i(this.lightIndexBottomRight);
+            tessellator.setShade1i((int) (this.shadeBottomRight * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedBottomRight, this.colorGreenBottomRight, this.colorBlueBottomRight);
             tessellator.addVertexWithUV(d12, d13, d15, d9, d11);
-            tessellator.setLightmapCoord1i(this.lightmapCoordTopRight);
+            tessellator.setLightmapCoord1i(this.lightIndexTopRight);
+            tessellator.setShade1i((int) (this.shadeTopRight * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedTopRight, this.colorGreenTopRight, this.colorBlueTopRight);
             tessellator.addVertexWithUV(d12, d13, d16, d4, d6);
         } else {
@@ -878,16 +891,20 @@ public final class RenderBlocks {
 
         tessellator.setNormal(1, 0, 0);
         if (this.enableAO) {
-            tessellator.setLightmapCoord1i(this.lightmapCoordTopLeft);
+            tessellator.setLightmapCoord1i(this.lightIndexTopLeft);
+            tessellator.setShade1i((int) (this.shadeTopLeft * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
             tessellator.addVertexWithUV(xMax, yMin, zMax, uMin2, vMax2);
-            tessellator.setLightmapCoord1i(this.lightmapCoordBottomLeft);
+            tessellator.setLightmapCoord1i(this.lightIndexBottomLeft);
+            tessellator.setShade1i((int) (this.shadeBottomLeft * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedBottomLeft, this.colorGreenBottomLeft, this.colorBlueBottomLeft);
             tessellator.addVertexWithUV(xMax, yMin, zMin, uMax, vMax);
-            tessellator.setLightmapCoord1i(this.lightmapCoordBottomRight);
+            tessellator.setLightmapCoord1i(this.lightIndexBottomRight);
+            tessellator.setShade1i((int) (this.shadeBottomRight * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedBottomRight, this.colorGreenBottomRight, this.colorBlueBottomRight);
             tessellator.addVertexWithUV(xMax, yMax, zMin, uMax2, vMin2);
-            tessellator.setLightmapCoord1i(this.lightmapCoordTopRight);
+            tessellator.setLightmapCoord1i(this.lightIndexTopRight);
+            tessellator.setShade1i((int) (this.shadeTopRight * 0xFF));
             tessellator.setColorOpaque3f(this.colorRedTopRight, this.colorGreenTopRight, this.colorBlueTopRight);
             tessellator.addVertexWithUV(xMax, yMax, zMax, uMin, vMin);
         } else {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java
index c34c1d07c..16fac720f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java
@@ -62,8 +62,8 @@ public class BlockModelGeneric<T extends BlockLogic> extends BlockModel<T> {
     }
 
     @Override
-    public void renderStandalone(final @NotNull TessellatorGeneral tessellator, final int metadata, final int lightmapCoord) {
-        getModelFromData(metadata).renderStandalone(this, tessellator, 0, 0, 0, metadata, lightmapCoord, BlockColorDispatcher.getInstance().getDispatch(this.block));
+    public void renderStandalone(final @NotNull TessellatorGeneral tessellator, final int metadata, final byte lightIndex) {
+        getModelFromData(metadata).renderStandalone(this, tessellator, 0, 0, 0, metadata, lightIndex, BlockColorDispatcher.getInstance().getDispatch(this.block));
     }
 
     public @NotNull StaticBlockModel getModel(@NotNull WorldSource source, @NotNull TilePosc tilePosc) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLamp.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLamp.java
index 0f10c01a3..1d713cfcf 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLamp.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLamp.java
@@ -21,8 +21,8 @@ public class BlockModelGenericLamp<T extends BlockLogic> extends BlockModelGener
     }
 
     @Override
-    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
-        this.activeModels[metadata & DyeColor.MASK_COLOR].renderStandalone(this, tessellator, 0, 0, 0, metadata, lightmapCoord, BlockColorDispatcher.getInstance().getDispatch(this.block));
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, byte lightIndex) {
+        this.activeModels[metadata & DyeColor.MASK_COLOR].renderStandalone(this, tessellator, 0, 0, 0, metadata, lightIndex, BlockColorDispatcher.getInstance().getDispatch(this.block));
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeavesCacao.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeavesCacao.java
index 2e3af8e99..8019babe2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeavesCacao.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeavesCacao.java
@@ -24,9 +24,9 @@ public class BlockModelGenericLeavesCacao<T extends BlockLogic> extends BlockMod
     }
 
     @Override
-    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
-        super.renderStandalone(tessellator, metadata, lightmapCoord);
-        this.overlays[this.overlays.length - 1].renderStandalone(this, tessellator, 0, 0, 0, metadata, lightmapCoord, BlockColorDispatcher.getInstance().getDispatch(this.block));
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, byte lightIndex) {
+        super.renderStandalone(tessellator, metadata, lightIndex);
+        this.overlays[this.overlays.length - 1].renderStandalone(this, tessellator, 0, 0, 0, metadata, lightIndex, BlockColorDispatcher.getInstance().getDispatch(this.block));
     }
 
     @Override
